// cl Client1.cpp Strings.cpp /O1 /Os /GS- /GR- /link TCLib.lib kernel32.lib user32.lib gdi32.lib UUID.lib ole32.lib oleaut32.lib
#define     UNICODE
#define     _UNICODE
//#define   MyDebug
#include    <windows.h>  
#include    <objbase.h>
#include    <ocidl.h>
#include    "stdio.h"
#include    "tchar.h"
#include    "Client1.h"
#include    "Strings.h"
const CLSID CLSID_FHGrid        =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}};
const IID   IID_IFHGrid         =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01}};
const IID   IID_IFHGridEvents   =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02}};
const IID   LIBID_FHGrid        =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03}};
extern "C"  int _fltused        =  1;

int _cdecl _purecall(void)      // Won't link against TCLib.lib without this useless function!
{
 return 0;
}

interface IGrid : IUnknown
{
 virtual HRESULT STDMETHODCALLTYPE CreateGrid          (HWND hParent, BSTR strSetup, int x, int y, int cx, int cy, int iRows, int iCols, int iRowHt, int iSelBkClr, int iSelTxtClr, BSTR strFntNme, int iFntSz, int iFntWt) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetRowCount         (int iRowCount, int blnForce) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetRowCount         (int* pRowCount) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetData             (int iRow, int  iCol, BSTR strData) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetData             (int iRow, int iCol, BSTR* strData) = 0;
 virtual HRESULT STDMETHODCALLTYPE FlushData           (void) = 0;
 virtual HRESULT STDMETHODCALLTYPE Refresh             (void) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetVisibleRows      (int* pVisibleRows) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethGrid            (HWND* hWnd) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethCell            (int iRow, int iCol, HWND* hCell) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethComboBox        (int iCol, HWND* hCombo) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetCellAttributes   (int iRow, int iCol, int iBackColor, int iTextColor) = 0;
 virtual HRESULT STDMETHODCALLTYPE DeleteRow           (int iRow) = 0;
};


interface IGridEvents : IUnknown
{
 virtual HRESULT STDMETHODCALLTYPE Grid_OnKeyPress     (int iKeyCode, int iKeyData, int iRow, int iCol, int* blnCancel) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnKeyDown      (int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnLButtonDown  (int iCellRow, int iGridRow, int iCol) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnLButtonDblClk(int iCellRow, int iGridRow, int iCol) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnPaste        (int iCellRow, int iGridRow, int iCol) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnRowSelection (int iRow, int iAction) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnDelete       (int iRow) = 0;
};


class CSink : public IGridEvents                        //CSink
{
 public:
 CSink();
 ~CSink();
 HRESULT STDMETHODCALLTYPE QueryInterface               (REFIID iid, void** ppv);
 ULONG   STDMETHODCALLTYPE AddRef                       ();
 ULONG   STDMETHODCALLTYPE Release                      ();
 HRESULT STDMETHODCALLTYPE Grid_OnKeyPress              (int iKeyCode, int iKeyData, int iRow, int iCol, int* blnCancel);
 HRESULT STDMETHODCALLTYPE Grid_OnKeyDown               (int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel);
 HRESULT STDMETHODCALLTYPE Grid_OnLButtonDown           (int CellRow, int GridRow, int Col);
 HRESULT STDMETHODCALLTYPE Grid_OnLButtonDblClk         (int CellRow, int GridRow, int Col);
 HRESULT STDMETHODCALLTYPE Grid_OnPaste                 (int CellRow, int GridRow, int Col);
 HRESULT STDMETHODCALLTYPE Grid_OnRowSelection          (int iRow, int iAction);
 HRESULT STDMETHODCALLTYPE Grid_OnDelete                (int iRow);

 private:
 HWND m_hWnd;
 long m_cRef;
};


CSink::CSink() : m_cRef(0), m_hWnd(0) 
{
 #ifdef MyDebug
 _tprintf(_T("  Entering CSink Constructor!\n"));
 #endif
 this->m_hWnd = FindWindow(_T("64 Bit Grid"),_T("64 Bit Grid ActiveX Control"));
 #ifdef MyDebug
 _tprintf(_T("    this         = %u\n"),this);
 _tprintf(_T("    this->m_cRef = %d\n"),this->m_cRef);
 _tprintf(_T("    this->m_hWnd = %u\n"),this->m_hWnd);
 _tprintf(_T("  Leaving CSink Constructor!\n\n"));
 #endif
}


CSink::~CSink()
{
 #ifdef MyDebug
 _tprintf(_T("      Entering CSink Destructor!\n"));
 _tprintf(_T("        this         = %u\n"),this);
 _tprintf(_T("        this->m_cRef = %d\n"),this->m_cRef);
 _tprintf(_T("      Leaving CSink Destructor!\n"));
 #endif
}


ULONG CSink::AddRef()
{
 #ifdef MyDebug
 _tprintf(_T("    Entering CSink::AddRef()\n"));
 #endif
 ++this->m_cRef;
 #ifdef MyDebug
 _tprintf(_T("      this->m_cRef = %d\n"),this->m_cRef);
 _tprintf(_T("    Leaving CSink::AddRef()\n"));
 #endif

 return m_cRef;
}


ULONG CSink::Release()
{
 #ifdef MyDebug
 _tprintf(_T("  Entering CSink::Release()\n"));
 _tprintf(_T("    this = %u\n"),this);
 #endif
 if(--m_cRef != 0)
 {
    #ifdef MyDebug
    _tprintf(_T("    m_cRef != 0 : m_cRef=%u\n"),m_cRef);
    _tprintf(_T("  Leaving CSink::Release()\n"));
    #endif
    return m_cRef;
 }
 else
 {
    #ifdef MyDebug
    _tprintf(_T("    m_cRef == 0 And Will Now Delete CSink!\n"));
    #endif
    delete this;
 }
 #ifdef MyDebug
 _tprintf(_T("  Leaving CSink::Release()\n"));
 #endif

 return 0;
}


HRESULT CSink::QueryInterface(REFIID riid, void** ppv)
{
 #ifdef MyDebug
 _tprintf(_T("  Entering CSink::QueryInterface() -- this = %u\n"),this);
 #endif
 if(riid == IID_IUnknown)
 {
    *ppv = (IUnknown*)this;
 }
 else if(riid == IID_IFHGridEvents)
 {
    #ifdef MyDebug
    _tprintf(_T("    Client: CSink::QueryInterface() for IID_IFHGridEvents  -- this = %u\n"), (IGridEvents*)this);
    #endif
    *ppv = (IGridEvents*)this;
    #ifdef MyDebug
    _tprintf(_T("    *ppv = %u\n"), *ppv);
    #endif
 }
 else
 {
    *ppv = NULL;
    return E_NOINTERFACE;
 }
 AddRef();
 #ifdef MyDebug
 _tprintf(_T("  Leaving CSink::QueryInterface(): this = %u\n"),this);
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnKeyPress(int KeyCode, int KeyData, int Row, int Col, int* blnCancel)
{
 #ifdef MyDebug
 _tprintf(_T("\nEntering CSink::Grid_OnKeyPress()\n"));
 _tprintf(_T("  CSink::Grid_OnKeyPress is %c\n"), KeyCode);
 _tprintf(_T("Leaving CSink::Grid_OnKeyPress()\n"));
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnKeyDown(int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel)
{
 #ifdef MyDebug
 _tprintf(_T("\nEntering CSink::Grid_OnKeyDown()\n"));
 _tprintf(_T("  CSink::Grid_OnKeyDown is %u\n"), KeyCode);
 _tprintf(_T("Leaving CSink::Grid_OnKeyDown()\n"));
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnLButtonDown(int iCellRow, int iGridRow, int iCol)
{
 #ifdef MyDebug
 _tprintf(_T("\nEntering CSink::Grid_OnLButtonDown()\n"));
 _tprintf(_T("  iGridRow = %d\n"),iGridRow);
 _tprintf(_T("  iCellRow = %d\n"),iCellRow);
 _tprintf(_T("  iCol     = %d\n"),iCol);
 _tprintf(_T("Leaving CSink::Grid_OnLButtonDown()\n"));
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnLButtonDblClk(int iCellRow, int iGridRow, int iCol)
{
 #ifdef MyDebug
 _tprintf(_T("\nEntering CSink::Grid_OnLButtonDblClk()\n"));
 _tprintf(_T("  CSink::Grid_OnLButtonDblClk: iGridRow = %u\tiCol = %u\n"),iGridRow,iCol);
 _tprintf(_T("Leaving CSink::Grid_OnLButtonDblClk()\n"));
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnPaste(int iCellRow, int iGridRow, int iCol)
{
 #ifdef MyDebug
 _tprintf(_T("\nEntering CSink::Grid_OnPaste()\n"));
 _tprintf(_T("  CSink::Grid_OnPaste: iGridRow=%u\tiCol=%u\n"), iGridRow,iCol);
 _tprintf(_T("Leaving CSink::Grid_OnPaste()\n"));
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnRowSelection(int iRow, int iAction)
{
 #ifdef MyDebug
 _tprintf(_T("\nEntering CSink::Grid_OnRowSelection()\n"));
 _tprintf(_T("  CSink::Grid_OnRowSelection: iRow=%d\tiAction=%d\n"),iRow,iAction);
 #endif
 if(this->m_hWnd)
 {
    if(iAction)
       SetWindowLongPtr(this->m_hWnd,2*sizeof_ptr,(LONG_PTR)iRow);
    else
       SetWindowLongPtr(this->m_hWnd,2*sizeof_ptr,(LONG_PTR)iAction);
 }
 #ifdef MyDebug
 _tprintf(_T("Leaving CSink::Grid_OnRowSelection()\n\n"));
 #endif

 return S_OK;
}


HRESULT CSink::Grid_OnDelete(int iRow)
{
 #ifdef MyDebug
 _tprintf(_T("Entering CSink::Grid_OnDelete()\n"));
 _tprintf(_T("  iRow = %d\n"),iRow);
 #endif
 IGrid* pGrid=(IGrid*)GetWindowLongPtr(this->m_hWnd,0*sizeof_ptr);
 #ifdef MyDebug
 _tprintf(_T("  pGrid = %u\n"),pGrid);
 #endif
 if(pGrid)
 {
    pGrid->DeleteRow(iRow);
    SetWindowLongPtr(this->m_hWnd,2*sizeof_ptr,(LONG_PTR)0);
 }
 #ifdef MyDebug
 _tprintf(_T("Leaving CSink::Grid_OnDelete()\n\n"));
 #endif

 return S_OK;
}


long fnWndProc_OnCreate(lpWndEventArgs Wea)
{
 HRESULT (__stdcall* ptrDllGetClassObject) (const CLSID&, const IID&, void**);  // code for registry free com	
 IConnectionPointContainer* pConnectionPointContainer=NULL;
 BSTR strSetup=NULL,strFontName=NULL,strCoordinate=NULL;
 IConnectionPoint* pConnectionPoint=NULL;
 IClassFactory* pClassFactory=NULL;
 SMALL_RECT sm_rect;
 CSink* pSink=NULL;
 IGrid* pGrid=NULL;
 HMODULE hDll=NULL;
 DWORD dwCookie=0;
 String s1,s2,s3;
 HWND hCtl=NULL;
 int iGridRows;
 HRESULT hr;
  
 Wea->hIns=((LPCREATESTRUCT)Wea->lParam)->hInstance;
 #ifdef MyDebug
 AllocConsole();
 HANDLE hStdOut=GetStdHandle(STD_OUTPUT_HANDLE);
 COORD pt;
 pt.X=120, pt.Y=600;
 SetConsoleScreenBufferSize(hStdOut,pt);
 sm_rect.Left=0, sm_rect.Top=0, sm_rect.Right=119, sm_rect.Bottom=39;
 SetConsoleWindowInfo(hStdOut,TRUE,&sm_rect);
 printf("Entering fnWndProc_OnCreate()\n");
 printf("  sizeof(IGrid*) = %d\n",sizeof(IGrid*));
 printf("  Wea->hWnd      = %u\n",Wea->hWnd);
 #endif
 hr=CoInitialize(NULL);
 if(SUCCEEDED(hr))
 {
    hCtl=CreateWindow(_T("button"),_T("Get Cell (3,2) Data"),WS_CHILD|WS_VISIBLE,10,10,200,30,Wea->hWnd,(HMENU)IDC_GET_DATA,Wea->hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Get Selected Row"),WS_CHILD|WS_VISIBLE,10,50,200,30,Wea->hWnd,(HMENU)IDC_GET_SELECTED_ROW,Wea->hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Get Row Count"),WS_CHILD|WS_VISIBLE,10,90,200,30,Wea->hWnd,(HMENU)IDC_GET_ROW_COUNT,Wea->hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Set Row Count"),WS_CHILD|WS_VISIBLE,10,130,200,30,Wea->hWnd,(HMENU)IDC_SET_ROW_COUNT,Wea->hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Get hCell"),WS_CHILD|WS_VISIBLE,10,170,200,30,Wea->hWnd,(HMENU)IDC_GET_HCELL,Wea->hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Color Some Rows"),WS_CHILD|WS_VISIBLE,10,210,200,30,Wea->hWnd,(HMENU)IDC_COLOR_SOME_ROWS,Wea->hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Destroy Grid"),WS_CHILD|WS_VISIBLE,10,250,200,30,Wea->hWnd,(HMENU)IDC_UNLOAD_GRID,Wea->hIns,NULL);
    #ifdef MyDebug
    printf("  CoInitialize() Succeeded!\n");
    #endif
    hDll=LoadLibrary(L"FHGrid.dll");
    if(hDll)
    {	    
       ptrDllGetClassObject=(HRESULT (__stdcall*)(REFCLSID, REFIID, void**))GetProcAddress(hDll,"DllGetClassObject");
       if(ptrDllGetClassObject)
	      { 
          hr=ptrDllGetClassObject(CLSID_FHGrid,IID_IClassFactory,(void**)&pClassFactory);
          if(SUCCEEDED(hr))
          {											
             printf("  pClassFactory = %u\n",pClassFactory);
             hr=pClassFactory->CreateInstance(NULL,IID_IFHGrid,(void**)&pGrid);
             if(SUCCEEDED(hr))
             {
                #ifdef MyDebug
                printf("  IClassFactory->CreateInstance() Succeeded!\n");
                printf("  pGrid = %u\n",pGrid);
                #endif
                SetWindowLongPtr(Wea->hWnd,0*sizeof_ptr,(LONG_PTR)pGrid);
                strSetup   = SysAllocString(L"110:Column 1:^:combo,110:Column 2:^:edit,110:Column 3:^:edit,110:Column 4:^:edit,110:Column 5:^:edit");
                strFontName= SysAllocString(L"Times New Roman");
                hr=pGrid->CreateGrid(Wea->hWnd,strSetup,250,10,570,273,NUMBER_OF_ROWS,NUMBER_OF_COLUMNS,28,0,0,strFontName,18,FW_NORMAL);
                if(SUCCEEDED(hr))
                {
                   #ifdef MyDebug
                   printf("  pGrid->CreateGrid() Succeeded!\n");
                   #endif
                   hr=pGrid->QueryInterface(IID_IConnectionPointContainer,(void**)&pConnectionPointContainer);
                   if(SUCCEEDED(hr))
                   {
                      #ifdef MyDebug
                      printf("  Got pConnectionPointContainer = %u\n",(size_t)pConnectionPointContainer);
                      #endif
                      hr = pConnectionPointContainer->FindConnectionPoint(IID_IFHGridEvents, &pConnectionPoint);
                      if(SUCCEEDED(hr))
                      {
                         #ifdef MyDebug
                         printf("  Got pConnectionPoint = %u\n\n",pConnectionPoint);
                         #endif
                         pSink=new CSink;
                         if(pSink)
                         {
                            #ifdef MyDebug
                            printf("  pSink = %u\n\n",pSink);
                            #endif
                            hr=pConnectionPoint->Advise((IUnknown*)pSink, &dwCookie);
                            if(SUCCEEDED(hr))
                            {
                               #ifdef MyDebug
                               _tprintf(_T("  pConnectionPoint->Advise() Succeeded!\n"));
                               #endif
                               SetWindowLongPtr(Wea->hWnd,1*sizeof_ptr,(long)dwCookie);
                               for(unsigned int i=1; i<=NUMBER_OF_ROWS; i++)
                               {
                                   s1=i;
                                   for(unsigned int j=1; j<=NUMBER_OF_COLUMNS; j++)
                                   {
                                       s2=j;
                                       s3=s1+_T(',')+s2;
                                       strCoordinate=SysAllocString(s3.lpStr());
                                       pGrid->SetData(i,j,strCoordinate);
                                       SysFreeString(strCoordinate);
                                   }
                               }
                               hCtl=0;
                               hr=pGrid->GethComboBox(1,&hCtl);
                               if(SUCCEEDED(hr))
                               {
                                  #ifdef MyDebug
                                  printf("  hCtl = %u\n",hCtl);
                                  #endif
                                  s1=L"Frederick", SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                                  s1=L"Elsie",     SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());  
                                  s1=L"Scott",     SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                                  s1=L"Lorrie",    SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                                  s1=L"Joseph",    SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                                  s1=L"Frank",     SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());    
                               }
                               pGrid->Refresh();
                            }
                            else
                            {
                               #ifdef MyDebug
                               printf("  pConnectionPoint->Advise() Failed!\n");
                               #endif
                            }
                         }
                         pConnectionPoint->Release();
                      }
                      else
                      {
                         #ifdef MyDebug
                         printf("  pConnectionPointContainer->FindConnectionPoint() Failed!\n");
                         #endif
                      }
                      pConnectionPointContainer->Release();
                   }
                   else
                   {
                      #ifdef MyDebug
                      printf("  pGrid->QueryInterface(IID_IConnectionPointContainer) Failed!\n");
                      #endif
                   }
                }
                else
                {
                   #ifdef MyDebug
                   printf("  pGrid->CreateGrid() Failed!\n");
                   #endif
                }
                SysFreeString(strSetup);
                SysFreeString(strFontName);
             }
             else
             {
                #ifdef MyDebug
                printf("  IClassFactory->CreateInstance() Failed!\n");
                #endif
             }
             pClassFactory->Release();
										}
          else
          {
             #ifdef MyDebug
             printf("  Got IClassFactory Pointer!\n");   
             #endif
          }									
       }
       else
       {
          #ifdef MyDebug
										printf("  GetProcAddress() Failed!\n");
          //printf("  CoGetClassObject() Failed!\n");
          #endif
       }
    }
    else
    {
					  #ifdef MyDebug
       printf("  LoadLibrary(FHGrid.dll) Failed!\n");   
							#endif
    }
	}
 else
 {
    #ifdef MyDebug
    printf("  CoInitialize() Failed!\n");
    #endif
 }
 #ifdef MyDebug
 printf("Leaving fnWndProc_OnCreate()\n\n");
 #endif

 return 0;
}


void DestroyGrid(HWND hHost)
{
 IConnectionPoint* pConnectionPoint=NULL;
 DWORD dwCookie=123456;

 #ifdef MyDebug
 printf("  Entering DestroyGrid()\n");
 #endif
 IGrid* pGrid=(IGrid*)GetWindowLongPtr(hHost,0);
 #ifdef MyDebug
 printf("  pGrid = %u\n",pGrid);
 #endif
 if(pGrid)
 {
    dwCookie=(DWORD)GetWindowLongPtr(hHost,1*sizeof_ptr);
    #ifdef MyDebug
    printf("    dwCookie = %u\n",dwCookie);
    #endif
    HRESULT hr=pGrid->QueryInterface(IID_IConnectionPoint,(void**)&pConnectionPoint);
    if(SUCCEEDED(hr))
    {
       #ifdef MyDebug
       printf("    pGrid->QueryInterface(IID_IConnectionPoint) Succeeded!\n");
       #endif
       hr=pConnectionPoint->Unadvise(dwCookie);
       if(SUCCEEDED(hr))
       {
          #ifdef MyDebug
          printf("   pConnectionPoint->Unadvise() Succeeded!\n");
          #endif
       }
       pConnectionPoint->Release();
    }
    pGrid->Release();
    SetWindowLongPtr(hHost,0,NULL);
 }
 #ifdef MyDebug
 printf("  Leaving DestroyGrid()\n");
 #endif
}


long fnWndProc_OnCommand(lpWndEventArgs Wea)
{
 switch(LOWORD(Wea->wParam))
 {
    case IDC_GET_DATA:
      {
         IGrid* pGrid=NULL;
         BSTR strData=SysAllocString(L"");
         pGrid=(IGrid*)GetWindowLongPtr(Wea->hWnd,0);
         if(pGrid)
         {
            pGrid->FlushData();
            HRESULT hr=pGrid->GetData(3,2,&strData);
            if(SUCCEEDED(hr))
            {
               #ifdef MyDebug
               _tprintf(_T("strData = %s\n"),strData);
               #else
               String s1=_T("strData = ");
               s1=s1+strData;
               MessageBox(Wea->hWnd,s1.lpStr(),_T("pGrid->GetData()"),MB_OK); 
               #endif
            }
            SysFreeString(strData);
         }
         break;
      }
    case IDC_GET_SELECTED_ROW:
      {
         int iRow=(int)GetWindowLongPtr(Wea->hWnd,2*sizeof_ptr);
         if(iRow)
         {
            TCHAR szNumber[16],szBuffer[64];
            _stprintf(szNumber,_T("%d"),iRow);
            _tcscpy(szBuffer,_T("Row # "));
            _tcscat(szBuffer,szNumber);
            _tcscat(szBuffer,_T(" Has Been Selected!"));
            MessageBox(Wea->hWnd,szBuffer,_T("Selection Results"),MB_OK);
         }
         else
            MessageBox(Wea->hWnd,_T("No Row Is Presently Selected!"),_T("Selection Results"),MB_OK);
         break;
      }
    case IDC_GET_ROW_COUNT:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea->hWnd,0);
         if(pGrid)
         {
            int iRowCount=0;
            HRESULT hr=pGrid->GetRowCount(&iRowCount);
            if(SUCCEEDED(hr))
            {
               TCHAR szBuffer[64],szNumber[16];
               _stprintf(szNumber,_T("%d"),iRowCount);
               _tcscpy(szBuffer,_T("The Grid Has "));
               _tcscat(szBuffer,szNumber);
               _tcscat(szBuffer,_T(" Row In It."));
               MessageBox(Wea->hWnd,szBuffer,_T("Row Count Report"),MB_OK);
            }
         }
         break;
      }
    case IDC_SET_ROW_COUNT:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea->hWnd,0);
         if(pGrid)
         {
            HRESULT hr=pGrid->SetRowCount(25,TRUE);
            if(SUCCEEDED(hr))
            {
               String s1,s2,s3;
               BSTR strCoordinate=NULL;
               for(unsigned int i=1; i<=25; i++)
               {
                   s1=i;
                   for(unsigned int j=1; j<=NUMBER_OF_COLUMNS; j++)
                   {
                       s2=j;
                       s3=s1+_T(',')+s2;
                       strCoordinate=SysAllocString(s3.lpStr());
                       pGrid->SetData(i,j,strCoordinate);
                       SysFreeString(strCoordinate);
                   }
               }
               pGrid->Refresh(); 
               MessageBox(Wea->hWnd,_T("pGrid->SetRowCount() Succeeded!"),_T("Report"),MB_OK);
            }
         }
         break;
      }
    case IDC_GET_HCELL:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea->hWnd,0);
         if(pGrid)
         {
            HWND hCell=0;
            HRESULT hr=pGrid->GethCell(3,2,&hCell);
            if(SUCCEEDED(hr))
            {
               TCHAR szBuffer[32];
               TCHAR szNumber[16];
               _tcscpy(szBuffer,(TCHAR*)_T("hCell (3,2) = "));
               _stprintf(szNumber,_T("%u"),hCell);
               _tcscat(szBuffer,szNumber);
               MessageBox(Wea->hWnd,szBuffer,_T("pGrid->GethCell(3,2)"),MB_OK);
            }
         }
         break;
      }
    case IDC_COLOR_SOME_ROWS:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea->hWnd,0);
         if(pGrid)
         {
            pGrid->FlushData();
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(3,i,0xFF,0xFFFFFF);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(4,i,0x00FF00,0xFFFFFF);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(5,i,0x00FF0000,0x00FFFFFF);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(6,i,0x00FFFF,0x00);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(7,i,0xFFFF00,0x01);
            pGrid->Refresh();
         }
         break;
      }
    case IDC_UNLOAD_GRID:
      {
         #ifdef MyDebug
         printf("\nEntering fnWndProc_OnCommand() -- IDC_UNLOAD_GRID\n");
         #endif
         DestroyGrid(Wea->hWnd);
         InvalidateRect(Wea->hWnd,NULL,TRUE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_UNLOAD_GRID),FALSE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_GET_DATA),FALSE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_GET_SELECTED_ROW),FALSE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_GET_ROW_COUNT),FALSE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_SET_ROW_COUNT),FALSE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_COLOR_SOME_ROWS),FALSE);
         EnableWindow(GetDlgItem(Wea->hWnd,IDC_GET_HCELL),FALSE);
         #ifdef MyDebug
         printf("Leaving fnWndProc_OnCommand()\n");
         #endif
         break;
      }
 }

 return 0;
}


long fnWndProc_OnDestroy(lpWndEventArgs Wea)
{
 #ifdef MyDebug
 printf("Entering fnWndProc_OnDestroy()\n");
 #endif
 DestroyGrid(Wea->hWnd);
 PostQuitMessage(0);
 #ifdef MyDebug
 printf("Leaving fnWndProc_OnDestroy()\n");
 #endif
 
 return 0;
}


LRESULT CALLBACK WndProc(HWND hwnd, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 WindowsEventArguments Wea;

 for(unsigned int i=0; i<dim(EventHandler); i++)
 {
     if(EventHandler[i].iMsg==msg)
     {
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*EventHandler[i].fnPtr)(&Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
 TCHAR szClass[]=_T("32 Bit Grid");
 WNDCLASSEX wc;
 HWND hWnd;
 MSG Msg;

 wc.lpszClassName=szClass,                 wc.lpfnWndProc=WndProc,                   wc.cbSize=sizeof(WNDCLASSEX);
 wc.style=0,                               wc.cbClsExtra=0,                          wc.cbWndExtra=3*sizeof_ptr;
 wc.hInstance=hInstance,                   wc.hIcon=LoadIcon(NULL,IDI_APPLICATION),  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW, wc.lpszMenuName=NULL,                     wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);
 RegisterClassEx(&wc);
 hWnd=CreateWindow(szClass,_T("64 Bit Grid ActiveX Control"),WS_OVERLAPPEDWINDOW,200,100,840,340,NULL,NULL,hInstance,NULL);
 ShowWindow(hWnd,nCmdShow);
 while(GetMessage(&Msg, NULL, 0, 0))
 {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
 }  CoFreeUnusedLibraries(), CoUninitialize();
 #ifdef MyDebug
 MessageBox(NULL,_T("... Before I Throw It Out!"),_T("Come And Get It ..."),MB_OK);
 #endif

 return (int)Msg.wParam;
}
